﻿using System;
using System.Collections.Generic;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using Bulldozer.Entities;

namespace Bulldozer.DrawningObjects
{
    public class DrawningFastBulldozer : DrawningBulldozer
    {
        public DrawningFastBulldozer(int speed, double weight,
            Color mainColor, Color optionalColor, bool covsh,
            bool rearbucket, int width, int height) :
            base(speed, weight, mainColor, width, height, 200, 110)
        {
            if (EntityTractor != null)
            {
                EntityTractor = new EntityFastBulldozer(speed, weight, mainColor,
                    optionalColor, covsh, rearbucket);
            }
        }
        public override void DrawTrasport(Graphics g)
        {
            if (EntityTractor is not EntityFastBulldozer fastTractor)
            {
                return;
            }
            Pen pen = new(fastTractor.OptionalColor, 2);

            if (fastTractor.Covsh)
            {
                Point[] trianglePoints = new Point[]
                {
                    new Point(_startPosX+50, _startPosY + 30),
                    new Point(_startPosX+50, _startPosY + 80),
                    new Point(_startPosX + 10, _startPosY + 80)
                };
                // Рисуем треугольник
                g.DrawPolygon(pen, trianglePoints);
            }
            if (fastTractor.Rearbucket)
            {
                Point[] trianglePoints = new Point[]
                {
                    new Point(_startPosX+150, _startPosY + 30),
                    new Point(_startPosX+180, _startPosY + 30),
                    new Point(_startPosX + 180, _startPosY + 80)
                };
                // Рисуем треугольник
                g.DrawPolygon(pen, trianglePoints);
            }
            base.DrawTrasport(g);
        }
    }
}
