﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bulldozer.DrawningObjects;
using Bulldozer.Drawnings;

namespace Bulldozer.MovementStrategy
{
    public class DrawningObjectBulldozer : IMoveableObject
    {
        private readonly DrawningBulldozer? _drawningTractor = null;
        public DrawningObjectBulldozer(DrawningBulldozer drawingTractor)
        {
            _drawningTractor = drawingTractor;
        }
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawningTractor == null || _drawningTractor.EntityTractor == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawningTractor.GetPosX,
                    _drawningTractor.GetPosY, _drawningTractor.GetWidth,
                    _drawningTractor.GetHeight);
            }
        }
        public int GetStep => (int)(_drawningTractor?.EntityTractor?.Step ?? 0);
        public bool CheckCanMove(DirectionTypeBulldozer direction) =>
            _drawningTractor?.CanMove(direction) ?? false;
        public void MoveObject(DirectionTypeBulldozer direction) =>
            _drawningTractor?.MoveTransport(direction);
        public void SetPosition(int x, int y)
        {
            if (_drawningTractor != null)
            {
                _drawningTractor.SetPosition(x, y);
            }
        }
        public void Draw(Graphics g)
        {
            if (_drawningTractor != null)
            {
                _drawningTractor.DrawTrasport(g);
            }
        }
    }
}
