﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bulldozer.DrawningObjects;
using Bulldozer.Entities;

namespace Bulldozer
{
    /// <summary>
    /// Расширение для класса EntityUsta
    /// </summary>
    public static class ExtentionDrawningBulldozer
    {
        /// <summary>
        /// Создание объекта из строки
        /// </summary>
        /// <param name="info">Строка с данными для создания объекта</param>
        /// <param name="separatorForObject">Разделитель даннных</param>
        /// <param name="width">Ширина</param>
        /// <param name="height">Высота</param>
        /// <returns>Объект</returns>
        public static DrawningBulldozer? CreateDrawningBulldozer(this string info, char
        separatorForObject, int width, int height)
        {
            string[] strs = info.Split(separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawningBulldozer(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]), width, height);
            }
            else if (strs.Length == 6)
            {
                return new DrawningFastBulldozer(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]),
                Color.FromName(strs[2]),
                Color.FromName(strs[3]),
                Convert.ToBoolean(strs[4]),
                Convert.ToBoolean(strs[5]), width, height);
            }
            return null;
        }
        /// <summary>
        /// Получение данных для сохранения в файл
        /// </summary>
        /// <param name="drawningBulldozer">Сохраняемый объект</param>
        /// <param name="separatorForBulldozer">Разделитель даннных</param>
        /// <returns>Строка с данными по объекту</returns>
        public static string GetDataForSave(this DrawningBulldozer drawningBulldozer,
        char separatorForBulldozer)
        {
            var bulldozer = drawningBulldozer.EntityTractor;
            if (bulldozer == null)
            {
                return string.Empty;
            }
            var str =
            $"{bulldozer.Speed}{separatorForBulldozer}{bulldozer.Weight}{separatorForBulldozer}{bulldozer.MainColor.Name}";
            if (bulldozer is not EntityFastBulldozer sportBulldozer)
            {
                return str;
            }
            return $"{str}{separatorForBulldozer}{sportBulldozer.OptionalColor.Name}{separatorForBulldozer}{sportBulldozer.Covsh}{separatorForBulldozer}{sportBulldozer.Rearbucket}";
        }
    }
}
