﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Bulldozer.DrawningObjects;
using Bulldozer.Drawnings;

namespace Bulldozer.MovementStrategy
{
    public interface IMoveableObject
    {
        /// <summary>
        /// получение координаты
        /// </summary>
        ObjectParameters? GetObjectPosition { get; }
        /// <summary>
        /// шаг
        /// </summary>
        int GetStep { get; }
        /// <summary>
        /// проверка можно ли инди в этом направлении
        /// </summary>
        /// <param name="direction"></param>
        /// <returns></returns>
        bool CheckCanMove(DirectionTypeBulldozer direction);
        /// <summary>
        /// изменение напрвления перемещения
        /// </summary>
        /// <param name="direction"></param>
        void MoveObject(DirectionTypeBulldozer direction);
        void SetPosition(int x, int y);
        void Draw(Graphics g);
    }
}
