﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer.MovementStrategy
{
    internal class MoveToBorder : AbstractStrategy
    {
        protected override bool IsTargetDestination()
        {
            var objParams = GetObjectParametrs;
            if (objParams == null)
            {
                return false;
            }
            return objParams.RightBorder <= FieldWidth &&
                objParams.RightBorder + GetStep() >= FieldWidth&&
                objParams.DownBorder <= FieldHeight &&
                objParams.DownBorder + GetStep() >= FieldHeight;
        }
        protected override void MoveToTarget()
        {
            var objParams = GetObjectParametrs;
            if (objParams == null)
            {
                return;
            }
            var diffX = objParams.RightBorder - FieldWidth;
            if (Math.Abs(diffX) > GetStep())
            {
                MoveRight();
            }
            var diffY = objParams.DownBorder - FieldHeight;
            if (Math.Abs(diffY) > GetStep())
            {
                MoveDown();
            }
        }
    }
}
